<?php
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
 
global $mainframe;
$user =& JFactory::getUser();
$gid = $user->get('gid',0);
$db = JFactory::getDBO();
$periodType = $params->get('periodtype',1);
if ($periodType=="Months") $periodTypeSQL = "MONTH";
if ($periodType=="Days") $periodTypeSQL = "DAY";
$periodInactive = $params->get('periodinactive',6); // the number of months or days of inactivity after which the member's account will be automatically deleted
$daysBetweenDeletes = $params->get('daysbetweendeletes',1);
$secondsBetweenDeletes = $daysBetweenDeletes * 24*60*60;
$dateLastDeleted = strtotime($params->get('datelastdeleted', "1970-01-01 00:00:00"));
$today = time();
$nextDayToDelete = $dateLastDeleted + $secondsBetweenDeletes;
$plan = $params->get('plan',1);
// Only execute if the currently viewing user is an administrator
if (($today > $nextDayToDelete) && ($gid=='25' || $gid=='24')){
    // delete members who have been expired for the specified number of months

    // Get those members' ids
    $sql = " SELECT userid FROM #__acctexp_subscr WHERE 
                                status='Expired' && 
                                lifetime != 1 && 
                                expiration < (NOW() - INTERVAL $periodInactive $periodTypeSQL) &&
                                userid in ( SELECT id FROM #__users )
            ";
    /*
    This query was useful when we first started using this plugin (it deleted members who had been imported from the old site), so I'm leaving it here in case we need it again
    $initialSql = " SELECT id FROM #__users WHERE 
                        lastVisitDate < ( NOW() - INTERVAL $monthsToDelete MONTH ) AND 
                        id IN ( SELECT userid FROM jos_acctexp_subscr WHERE 
                            status = 'Expired' AND 
                            lifetime != 1 
                        ) ";
    $sql = $initialSql;
    */
    $db->setquery($sql);
    $ids = $db->loadAssocList();

    // for each member returned, run Joomla's cbDeleteuser() API call
    foreach ($ids as $arr){
        $userToDelete = JFactory::getUser($arr['userid']);
        $userToDelete->delete();
    }

    // report how many members were automatically deleted
    $numDeleted = count($ids);
    $periodReport = strtolower($periodType);
    if ($numDeleted > 0) $mainframe->enqueueMessage("$numDeleted members were automatically deleted because their accounts expired $periodInactive $periodReport ago. Don't worry, only administrators see this message! : )", 'message');
        
    // Write $today to $params.  Apparently $params->set() only writes to the plugin object's in-memory copy of the params, and not to the database, so we have to write the raw params back to the db.
    // TODO: Configure for Jomsocial
    $dateLastDeleted = date('Y-m-d H:i:s', $today);
    $newParams = "periodtype=$periodType
periodinactive=$periodInactive
daysbetweendeletes=$daysBetweenDeletes
datelastdeleted=$dateLastDeleted
plan=$plan";
    $db->setquery("UPDATE #__comprofiler_plugin SET params='$newParams' WHERE element='deleteinactive'");
    $result = $db->query();
}

?>

